<?php
/**
 * @package     Class Overrider plugin (Presentation at JoomlaDay 2012 Greece by JoomlaFans.gr - Zgouletas Stergios)
 * @version     1.1
 * @author      Stergios Zgouletas <info@web-expert.gr>
 * @link        http://www.web-expert.gr
 * @copyright   Copyright (C) 2010 Web-Expert.gr All Rights Reserved
 * @license     http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */
defined('_JEXEC') or die;
if(!defined('DS')) define('DS',DIRECTORY_SEPARATOR);
jimport( 'joomla.plugin.plugin');
class plgSystemClassoverrider extends JPlugin
{

	function __construct(& $subject, $config)
	{
		parent::__construct($subject, $config);
		$plugin = JPluginHelper::getPlugin('system', 'classoverrider');
		$this->params=class_exists('JParameter') ? new JParameter($plugin->params) : new JRegistry($plugin->params);
	}

	function onAfterRoute()
	{
		#Vars
		$app = JFactory::getApplication();
		$ClassPaths=$this->params->get('classpath','');
		$debug=(int)$this->params->get('debug',0);
		$option=JRequest::getCMD('option');
		$view=JRequest::getCMD('view');
		$task=JRequest::getCMD('task');
		$layout=JRequest::getCMD('layout');
		
		#Check
		if(empty($ClassPaths)) return;
		$classesToOverride =@explode("\n",$ClassPaths);
	    $isAdmin=$app->isAdmin();
		$html='<div style="border:2px dotted red"><b>Class Overrider Debug:</b><br/>';
		foreach($classesToOverride as $cPaths){
			$classDetails=@explode('|',trim($cPaths),2); 
			$params=$this->getParams($classDetails[0]);
		
			if(!$isAdmin && $params["env"]=='admin') continue; // skip admin classes if front-end is loaded
			
			#Load the class only if the component is requested or forced
			if( ($params["compo"]==$option || $params["compo"]=='force') && ($task==null || $task==$params['task']) && ($layout==null || $layout==$params['layout']) && ($view==null || $view==$params['view'])) {
				#Path Fix checks
				$classDetails[1]=str_replace(array("/","\\"),DS,$classDetails[1]); #Fix slash
				if($params["path"]!='absolute'){
					if(substr($classDetails[1],0,1)==DS) $classDetails[1]=substr($classDetails[1],1); #Checks if starts with slash and remove it
					$loadClass=JPATH_ROOT.DS.$classDetails[1];
				}else{
					$loadClass=$classDetails[1];
				}

				if(JFile::exists($loadClass)){
					require_once($loadClass); #Load the custom class
					$html.='File exists & Loaded:'.$loadClass;
				}else{
					$html.='File does not exists & Not loaded:'.$loadClass;
				}
				$html.='<br/>'.print_r($params,true).'<br/>';
			}
			unset($classDetails,$params);
		}
		$html.='</div>';
		if($debug) echo $html;
	}
	
	function getParams($p){
		$params=array('path'=>null,'compo'=>'force','view'=>null,'task'=>null,'layout'=>null,'env'=>'site');
		if(empty($p)) return $params;
		$pp=explode(',',$p);
		foreach($pp as $np){
			$vals=explode(":",$np,2);
			$params[trim(JString::strtolower($vals[0]))]=trim(JString::strtolower($vals[1]));
		}
		return $params;
	}
}